void ExtractSR(clsChar* TargetStruct)
{
	char* PDesc;
	int SR;

	if (PDesc = strstr(TargetStruct->CharText, "Spell Resis"))
	{
		sscanf(PDesc, "Spell Resistance %d\n", &SR);
		if (strstr(PDesc, "\n"))
		{
			strcpy(PDesc, strstr(PDesc, "\n") + strlen("\n"));
		}
		else
		{
			PDesc[0] = 0;
		}
		TargetStruct->MR = max(TargetStruct->MR, SR);
	}
}

void SetMonsterSpellChar(clsChar* TargetStruct)
{
	int i, j, k;
	char* pSpellChar;
	int pSpellCharLen;
	char* CharName;
	char* pCharName;
	int Level;

	if (Source.MonsterSource[TargetStruct->MonsterName].SpellChar[0] != '0')
	{
		TargetStruct->ClassCount = 0;
		pSpellChar = Source.MonsterSource[TargetStruct->MonsterName].SpellChar;
		while (*pSpellChar)
		{
			CharName = (char*) mallocl(strlen(pSpellChar), "SetMonsterSpellChar-CharName");

			pSpellCharLen = strlen(pSpellChar);
			sscanf(pSpellChar, "%s %d", CharName, &Level);
			if (strstr(CharName, "|"))
			{
				i = 0;
				for (j = 0;j < (signed) strlen(CharName);j++)
				{
					if (CharName[j] == '|')
					{
						i++;
					}
				}
				k = random(0, i, "Welcher Spellchar");
				i = 0;
				for (j = 0;j < (signed) strlen(CharName);j++)
				{
					if (i == k)
					{
						pCharName = &CharName[j];
						str_replace('|', 0, pCharName);
						break;
					}
					if (CharName[j] == '|')
					{
						i++;
					}
				}
			}
			else
			{
				pCharName = CharName;
			}
			TargetStruct->Classes[TargetStruct->ClassCount] = GetCharNumber(pCharName);
			TargetStruct->Levels[TargetStruct->ClassCount] = Level;
			TargetStruct->ClassCount++;
			pSpellChar += pSpellCharLen + 1;

			freel(CharName);
		}
		for (i = 0;i < TargetStruct->ClassCount;i++)
		{
			TargetStruct->DummyClass[i] = 1;
			TargetStruct->DummyClassClericSpells[i] = Source.MonsterSource[TargetStruct->MonsterName].ClericSpells;
		}
	}
}

void ChangeSizeDmg(int* dmg1, int* dmg2)
{
	if (*dmg2 == 2)
	{
		*dmg2 = 3;
	}
	else if (*dmg2 == 3)
	{
		*dmg2 = 4;
	}
	else if (*dmg2 == 4)
	{
		*dmg2 = 6;
	}
	else if (*dmg2 == 6)
	{
		*dmg2 = 8;
	}
	else if (*dmg2 == 8)
	{
		*dmg2 = 6;
		*dmg1 *= 2;
	}
	else if (*dmg2 == 10)
	{
		*dmg2 = 6;
		*dmg1 *= 2;
	}
	else if (*dmg2 == 12)
	{
		*dmg2 = 8;
		*dmg1 *= 2;
	}
}

void IncreaseAttributes(clsChar* TargetStruct, int* NewAttributes, int Num = 6, int AttributeOnly = 0)
{
	int OldMods[6];
	int i;

	CalcMods(TargetStruct);
	CopyMemory(OldMods, TargetStruct->Mods, 6 * sizeof(int));
	for (i = 0;i < Num;i++)
	{
		TargetStruct->Attributes[i] += NewAttributes[i];
	}
	CalcMods(TargetStruct);

	if (AttributeOnly)
	{
		return;
	}

	TargetStruct->AC += TargetStruct->Mods[1] - OldMods[1];
	TargetStruct->RWRef += TargetStruct->Mods[1] - OldMods[1];
	TargetStruct->RWWil += TargetStruct->Mods[4] - OldMods[4];
	TargetStruct->RWZaeh += TargetStruct->Mods[2] - OldMods[2];

	TargetStruct->Life += TargetStruct->Level * (TargetStruct->Mods[2] - OldMods[2]);

	for (i = 0;i < TargetStruct->MAttackCount;i++)
	{
		TargetStruct->MAttackBonus[i] += Source.SizeSource[TargetStruct->MSize].SizeMod;
		TargetStruct->MAttackBonus[i] += TargetStruct->Mods[0] - OldMods[0];
		TargetStruct->MDamageC[i] += TargetStruct->Mods[0] - OldMods[0];
		ChangeSizeDmg(&TargetStruct->MDamageA[i], &TargetStruct->MDamageB[i]);
	}
}

void IncreaseSize(clsChar* TargetStruct)
{
	int i;

	TargetStruct->AC += Source.SizeSource[TargetStruct->MSize].AC;
	TargetStruct->AC += Source.SizeSource[TargetStruct->MSize].SizeMod;
	for (i = 0;i < TargetStruct->MAttackCount;i++)
	{
		TargetStruct->MAttackBonus[i] += Source.SizeSource[TargetStruct->MSize].SizeMod;
	}

	IncreaseAttributes(TargetStruct, Source.SizeSource[TargetStruct->MSize].Mods, 3);
	
	TargetStruct->MSize++;
	TargetStruct->MonsterSize++;
}

void DoMonsterDesc(clsChar* TargetStruct, char* FileName)
{
	clsMonsterDescSource* CurDesc = Source.MonsterDesc;

	ucase(FileName);

	while (CurDesc)
	{
		if (CurDesc->FileName == FileName)
		{
			strcat(TargetStruct->CharText, CurDesc->Content.buffer);
			return;
		}
		CurDesc = CurDesc->NextElem;
	}
	printf("Could not Find Text for Monster\n");
	quitprog();
}

void DoMonsterDesc2(string* strText, char* FileName)
{
	FILE* fMonster;
	int i;
	char* buffer;
	char* buffertest;
	char* IncludeFile;
	fMonster = fopen(FileName, "r");
	if (fMonster == 0)
	{
		printf("Error opening File %s\n", FileName);
		quitprog();
	}

	fseek(fMonster, 0, SEEK_END);
	buffer = (char*) mallocl(ftell(fMonster) + 1, "DoMonsterDesc-buffer");
	fseek(fMonster, 0, SEEK_SET);

	while (!feof(fMonster))
	{
		buffer[0] = 0;
		fgets(buffer, 8191, fMonster);
		for (i = 0;i < (signed) strlen(buffer);i++)
		{
			if (buffer[i] == 13 || buffer[i] == 10)
			{
				buffer[i] = 0;
			}
		}

		buffertest = (char*) mallocl(strlen(buffer) + 1, "DoMonsterDesc-buffertest");
		strncpy(buffertest, buffer, strlen("include"));
		buffertest[strlen("include")] = 0;
		if (strcmp(buffertest, "include") == 0)
		{
			sscanf(buffer, "include %s", buffertest);
			IncludeFile = (char*) mallocl(strlen(buffertest) + 13, "DoMonsterDesc-IncludeFile");
			sprintf(IncludeFile, "MonsterText\\%s", buffertest);
			DoMonsterDesc2(strText, IncludeFile);
			freel(IncludeFile);
		}
		else
		{
			*strText += buffer;
			if (strlen(buffer) == 0)
			{
				*strText += "\n";
			}
			else
			{
				*strText += " ";
			}
		}
		freel(buffertest);
	}
	*strText += "\n";

	freel(buffer);

	fclose(fMonster);
}

void InitMonsterDesc()
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hSearch;

	clsMonsterDescSource** CurDesc = &Source.MonsterDesc;

	hSearch = FindFirstFile("MonsterText\\*.*", &FindFileData);
	if (hSearch != INVALID_HANDLE_VALUE)
	{
		do
		{
			if (FindFileData.cFileName[0] != '.')
			{
				SetNewIdent("InitMonsterDesc-CurDesc");
				*CurDesc = new clsMonsterDescSource;
				if (CurDesc == 0)
				{
					printf("Memmory Allocation Error\n");
					exit(1);
				}

				(*CurDesc)->FileName = "MonsterText\\";
				(*CurDesc)->FileName += FindFileData.cFileName;
				ucase((*CurDesc)->FileName);
				DoMonsterDesc2(&(*CurDesc)->Content, (*CurDesc)->FileName.buffer);
				CurDesc = &(*CurDesc)->NextElem;
			}
		} while (FindNextFile(hSearch, &FindFileData));
		FindClose(hSearch);
	}

}

void GetMonsterGARW(clsChar* TargetStruct, int* GA, int* RWRef, int* RWWil, int* RWZaeh)
{
	if (!TargetStruct->Monster)
	{
		*GA = GetGA(TargetStruct->Level, 1);
		*RWRef = *RWWil = *RWZaeh = GetRW(TargetStruct->Level, 1);
		return;
	}
	else
	{
		*GA = GetGA(TargetStruct->Level, Source.MonsterTypeSource[TargetStruct->MonsterType].GAType);
		*RWRef = GetRW(TargetStruct->Level, Source.MonsterTypeSource[TargetStruct->MonsterType].RWRefType);
		*RWWil = GetRW(TargetStruct->Level, Source.MonsterTypeSource[TargetStruct->MonsterType].RWWilType);
		*RWZaeh = GetRW(TargetStruct->Level, Source.MonsterTypeSource[TargetStruct->MonsterType].RWZaehType);
	}
}

void SetMonster(clsChar* TargetStruct)
{
	int i;
	int PosProb[32];
	int PosType;
	int OldGA, NewGA;
	int OldRWRef, NewRWRef;
	int OldRWWil, NewRWWil;
	int OldRWZaeh, NewRWZaeh;
	int OldType, NewType;

	double NewHDMax, HDLog;
	int a, temp2;

	sprintf(tempout, "Template whlen!\n");
	for (i = 0;i < TargetStruct->CRPosCount;i++)
	{
		sprintf(tempout2, "%d: Template: %s, TW Erhhung: %d\n", i, Source.TemplateSource[TargetStruct->CRPosTemplate[i]].Name.buffer, TargetStruct->CRPosHD[i]);
		strcat(tempout, tempout2);
		PosProb[i] = 1;
		if (TargetStruct->CRPosTemplate[i] == 0)
		{
			PosProb[i] += 15;
		}
		if (TargetStruct->CRPosHD[i] == 0)
		{
			PosProb[i] += 5;
		}
	}
	PosType = AdvancedRand(TargetStruct->CRPosCount, PosProb, sizeof(int), "", 0, tempout);

	sprintf(tempout, "Template: %s, Bonus TW Level: %d\n", Source.TemplateSource[TargetStruct->CRPosTemplate[PosType]].Name.buffer, TargetStruct->CRPosHD[PosType]);
	strcat(TargetStruct->CharText, tempout);

	TargetStruct->MonsterTWType = Source.MonsterSource[TargetStruct->MonsterName].HDType;
	TargetStruct->MonsterSize = Source.MonsterSource[TargetStruct->MonsterName].Size;
	TargetStruct->MonsterType = Source.MonsterSource[TargetStruct->MonsterName].Type;
	OldType = TargetStruct->MonsterType;
	TargetStruct->ClassCount = 0;
	TargetStruct->Level = Source.MonsterSource[TargetStruct->MonsterName].HD;

	GetMonsterGARW(TargetStruct, &OldGA, &OldRWRef, &OldRWWil, &OldRWZaeh);

	sprintf(tempout, "MonsterText\\%s", Source.TemplateSource[TargetStruct->CRPosTemplate[PosType]].Name.buffer);
	DoMonsterDesc(TargetStruct, tempout);

	mGetStatic(sisave_SM_TCe, sbsave_SM_TCe, GetTemplateNumber("Celestial"));
	mGetStatic(sisave_SM_TFi, sbsave_SM_TFi, GetTemplateNumber("Fiendish"));
	if (TargetStruct->CRPosTemplate[PosType] == sisave_SM_TCe || TargetStruct->CRPosTemplate[PosType] == sisave_SM_TFi)
	{
		mGetStatic(sisave_SM_Be, sbsave_SM_Be, GetMonsterTypeNumber("Beast"));
		mGetStatic(sisave_SM_An, sbsave_SM_An, GetMonsterTypeNumber("Animal"));
		mGetStatic(sisave_SM_MaBe, sbsave_SM_MaBe, GetMonsterTypeNumber("MagicalBeast"));
		if (TargetStruct->MonsterType == sisave_SM_Be || TargetStruct->MonsterType == sisave_SM_An)
		{
			TargetStruct->MonsterType = sisave_SM_MaBe;
		}
	}

	if (Source.TemplateSource[TargetStruct->CRPosTemplate[PosType]].NewType.buffer[0] != ';')
	{
		TargetStruct->MonsterType = GetMonsterTypeNumber(Source.TemplateSource[TargetStruct->CRPosTemplate[PosType]].NewType.buffer);
	}
	
	for (i = 0;i < 6;i++)
	{
		TargetStruct->Attributes[i] = Source.MonsterSource[TargetStruct->MonsterName].Attr[i];
	}

	CalcMods(TargetStruct);
	
	TargetStruct->Initiative = Source.MonsterSource[TargetStruct->MonsterName].Init;
	TargetStruct->InitiativeDex = TargetStruct->Mods[1];
	TargetStruct->InitiativeRest = 0;
	
	TargetStruct->AC = Source.MonsterSource[TargetStruct->MonsterName].AC;

	TargetStruct->RWRef = Source.MonsterSource[TargetStruct->MonsterName].RWRef;
	TargetStruct->RWWil = Source.MonsterSource[TargetStruct->MonsterName].RWWil;
	TargetStruct->RWZaeh = Source.MonsterSource[TargetStruct->MonsterName].RWZaeh;

	temp2 = Source.Treasure[TargetStruct->HG];

	TargetStruct->Money = random(75, 175, "Geldwert in %%") * temp2 / 100 * Source.MonsterSource[TargetStruct->MonsterName].Treasure;
	TargetStruct->MoneyRest = TargetStruct->Money;
	TargetStruct->Treasure = TargetStruct->Money;
	TargetStruct->TreasureLeft = TargetStruct->Money;

	TargetStruct->Range = (float) Source.MonsterSource[TargetStruct->MonsterName].Speed / 10 * 3;

	TargetStruct->AttackType[0] = AttackMonster;
	TargetStruct->AttackType[1] = AttackNone;

	mGetStatic(sisave_SM_Dr, sbsave_SM_Dr, GetMonsterTypeNumber("Dragon"));
	if (Source.MonsterSource[TargetStruct->MonsterName].Type == sisave_SM_Dr &&
		Source.MonsterSource[TargetStruct->MonsterName].FeatCount == 0)
	{
		TargetStruct->FeatCount = Source.MonsterSource[TargetStruct->MonsterName].HD / 4;
		TargetStruct->SkillPoints = (Source.MonsterSource[TargetStruct->MonsterName].HD + 3) * (6 + Source.MonsterSource[TargetStruct->MonsterName].Attr[3]);

		int PMod[4096];
		for (i = 0;i < 4096;i++) {PMod[i] = 0;}

		mGetStatic(sisave_SM_Kae, sbsave_SM_Kae, GetCharNumber("Kmpfer"));
		mGetStatic(sisave_SM_He, sbsave_SM_He, GetCharNumber("Hexenmeister"));
		mGetStatic(sisave_SM_Ma, sbsave_SM_Ma, GetCharNumber("Magier"));
		i = 0;
		TargetStruct->ClassCount = 1;
		TargetStruct->Classes[0] = sisave_SM_Kae;
		TargetStruct->FeatCount /= 2;
		TargetStruct->Levels[0] = 20;
		DoFeats(TargetStruct, PMod, sisave_SM_Kae, false, &i, Source.MonsterSource[TargetStruct->MonsterName].Epic);

		TargetStruct->Classes[0] = sisave_SM_He;
		i = TargetStruct->FeatCount;
		TargetStruct->FeatCount *= 2;
		DoFeats(TargetStruct, PMod, sisave_SM_Ma, false, &i, Source.MonsterSource[TargetStruct->MonsterName].Epic);
		TargetStruct->ClassCount = 0;
		CalculateSkills(TargetStruct, 1);

		for (i = 0;i < TargetStruct->FeatCount;i++)
		{
			TargetStruct->FeatDone[i] = 1;
			if (strstr(Source.FeatSource[TargetStruct->Feats[i]].Name, "Waffen") && TargetStruct->FeatDependancy[i] != -2)
			{
				mGetStatic(sisave_SM_Kla, sbsave_SM_Kla, GetEquipNumber("Klaue"));
				TargetStruct->FeatDependancy[i] = sisave_SM_Kla;
				TargetStruct->FeatDone[i] = 0;
			}
		}
	}
	else
	{
		for (i = 0;i < Source.MonsterSource[TargetStruct->MonsterName].FeatCount;i++)
		{
			TargetStruct->Feats[i] = Source.MonsterSource[TargetStruct->MonsterName].Feats[i];
			TargetStruct->FeatDone[i] = 1;
			TargetStruct->FeatDependancy[i] = -2;
		}
		TargetStruct->FeatCount = Source.MonsterSource[TargetStruct->MonsterName].FeatCount;

		for (i = 0;i < Source.MonsterSource[TargetStruct->MonsterName].SkillCount;i++)
		{
			TargetStruct->Skills[i] = Source.MonsterSource[TargetStruct->MonsterName].Skills[i];
			TargetStruct->SkillLevels[i] = Source.MonsterSource[TargetStruct->MonsterName].SkillLevels[i];
			TargetStruct->SkillLevels2[i] = 0;
			TargetStruct->SkillPoints += Source.MonsterSource[TargetStruct->MonsterName].SkillLevels[i];
		}
		TargetStruct->SkillPoints = 0;
		TargetStruct->SkillCountReal = 0;
		TargetStruct->SkillCount = Source.MonsterSource[TargetStruct->MonsterName].SkillCount;
	}

	for (i = 0;i < Source.MonsterSource[TargetStruct->MonsterName].AttackCount;i++)
	{
		TargetStruct->MAttackBonus[i] = Source.MonsterSource[TargetStruct->MonsterName].AttackBonus[i];
		TargetStruct->MAttackNumber[i] = Source.MonsterSource[TargetStruct->MonsterName].AttackNumber[i];
		TargetStruct->MAttackRed[i] = Source.MonsterSource[TargetStruct->MonsterName].AttackRed[i];
		TargetStruct->MDamageA[i] = Source.MonsterSource[TargetStruct->MonsterName].DamageA[i];
		TargetStruct->MDamageB[i] = Source.MonsterSource[TargetStruct->MonsterName].DamageB[i];
		TargetStruct->MDamageC[i] = Source.MonsterSource[TargetStruct->MonsterName].DamageC[i];
		TargetStruct->MAlternateAttack[i] = Source.MonsterSource[TargetStruct->MonsterName].AlternateAttack[i];
		TargetStruct->MAttackType[i] = Source.MonsterSource[TargetStruct->MonsterName].AttackType[i];
	}
	TargetStruct->MAttackCount = Source.MonsterSource[TargetStruct->MonsterName].AttackCount;

	TargetStruct->MSize = Source.MonsterSource[TargetStruct->MonsterName].Size;

	TargetStruct->Life = Source.MonsterSource[TargetStruct->MonsterName].TPBonus;

	int hdcount = 0;
	do
	{
		if (TargetStruct->CRPosHD[PosType] == 0)
		{
			TargetStruct->Level = Source.MonsterSource[TargetStruct->MonsterName].HD;
		}
		if (TargetStruct->CRPosHD[PosType] == 1)
		{
			if (Source.MonsterSource[TargetStruct->MonsterName].HDInc > 0)
			{
				TargetStruct->Level = random(Source.MonsterSource[TargetStruct->MonsterName].HDMin, Source.MonsterSource[TargetStruct->MonsterName].HDInc - 1, "Trefferwrfel:");
			}
			else
			{
				TargetStruct->Level = random(Source.MonsterSource[TargetStruct->MonsterName].HDMin, Source.MonsterSource[TargetStruct->MonsterName].HDMax, "Trefferwrfel:");
			}
		}

		if (TargetStruct->CRPosHD[PosType] == 2)
		{
			if (Source.MonsterSource[TargetStruct->MonsterName].HDInc2 > 0)
			{
				TargetStruct->Level = random(Source.MonsterSource[TargetStruct->MonsterName].HDInc, Source.MonsterSource[TargetStruct->MonsterName].HDInc2 - 1, "Trefferwrfel:");
			}
			else
			{
				TargetStruct->Level = random(Source.MonsterSource[TargetStruct->MonsterName].HDInc, Source.MonsterSource[TargetStruct->MonsterName].HDMax, "Trefferwrfel:");
			}
		}

		if (TargetStruct->CRPosHD[PosType] == 3)
		{
			TargetStruct->Level = random(Source.MonsterSource[TargetStruct->MonsterName].HDInc2, Source.MonsterSource[TargetStruct->MonsterName].HDMax, "Trefferwrfel:");
		}

		NewHDMax = TargetStruct->Level;
		NewHDMax /= GreaterZero(Source.MonsterSource[TargetStruct->MonsterName].HD);
		HDLog = log((double) NewHDMax) / log((double) 2);
		a = (int) (max(TargetStruct->CRPosHD[PosType], (int) (HDLog * 4 + 0.5)));
		a += TargetStruct->CRPosCR[PosType];

		if (a != TargetStruct->HG)
		{
			a = a;
			hdcount++;
		}
	} while (a != TargetStruct->HG && hdcount < 1000);

	if (TargetStruct->Level > Source.MonsterSource[TargetStruct->MonsterName].HDInc && Source.MonsterSource[TargetStruct->MonsterName].HDInc > 0)
	{
		IncreaseSize(TargetStruct);
	}

	if (TargetStruct->Level > Source.MonsterSource[TargetStruct->MonsterName].HDInc2 && Source.MonsterSource[TargetStruct->MonsterName].HDInc2 > 0)
	{
		IncreaseSize(TargetStruct);
	}
	
	
	if (TargetStruct->Level > 200)
	{
		printf("Invalid Level\n");
		quitprog();
	}

	for (i = 0;i < TargetStruct->Level;i++)
	{
		TargetStruct->Life += random(1, TargetStruct->MonsterTWType, "Trefferwrfel");
	}

	IncreaseAttributes(TargetStruct, Source.TemplateSource[TargetStruct->CRPosTemplate[PosType]].AttributeMod);

	mGetStatic(sisave_SM_THCe, sbsave_SM_THCe, GetTemplateNumber("Half-Celestial"));
	if (TargetStruct->CRPosTemplate[PosType] == sisave_SM_THCe)
	{
		if (TargetStruct->Attributes[4] >= 8)
		{
			if (TargetStruct->Level >= 19) {strcat(TargetStruct->CharText, "Zauber: Resurrection\n");}
			else if (TargetStruct->Level >= 17) {strcat(TargetStruct->CharText, "Zauber: Summon monster IX (celestials only)\n");}
			else if (TargetStruct->Level >= 15) {strcat(TargetStruct->CharText, "Zauber: Symbol\n");}
			else if (TargetStruct->Level >= 13) {strcat(TargetStruct->CharText, "Zauber: Holy aura 3/day, hallow\n");}
			else if (TargetStruct->Level >= 11) {strcat(TargetStruct->CharText, "Zauber: Holy word\n");}
			else if (TargetStruct->Level >= 9) {strcat(TargetStruct->CharText, "Zauber: Dispel evil\n");}
			else if (TargetStruct->Level >= 7) {strcat(TargetStruct->CharText, "Zauber: Holy smite, remove disease\n");}
			else if (TargetStruct->Level >= 5) {strcat(TargetStruct->CharText, "Zauber: Cure serious wounds, neutralize poison\n");}
			else if (TargetStruct->Level >= 3) {strcat(TargetStruct->CharText, "Zauber: Aid, detect evil\n");}
			else if (TargetStruct->Level >= 1) {strcat(TargetStruct->CharText, "Zauber: Protection from evil, 3/day, bless\n");}
		}
	}

	mGetStatic(sisave_SM_THFi, sbsave_SM_THFi, GetTemplateNumber("Half-Fiend"));
	if (TargetStruct->CRPosTemplate[PosType] == sisave_SM_THFi)
	{
		if (TargetStruct->Attributes[4] >= 8)
		{
			if (TargetStruct->Level >= 19) {strcat(TargetStruct->CharText, "Zauber: Destruction\n");}
			else if (TargetStruct->Level >= 17) {strcat(TargetStruct->CharText, "Zauber: Summon monster IX (fiends only)\n");}
			else if (TargetStruct->Level >= 15) {strcat(TargetStruct->CharText, "Zauber: Horrid wilting\n");}
			else if (TargetStruct->Level >= 13) {strcat(TargetStruct->CharText, "Zauber: Unholy aura 3/day, unhallow\n");}
			else if (TargetStruct->Level >= 11) {strcat(TargetStruct->CharText, "Zauber: Blasphemy\n");}
			else if (TargetStruct->Level >= 9) {strcat(TargetStruct->CharText, "Zauber: Contagion\n");}
			else if (TargetStruct->Level >= 7) {strcat(TargetStruct->CharText, "Zauber: Poison 3/day\n");}
			else if (TargetStruct->Level >= 5) {strcat(TargetStruct->CharText, "Zauber: Unholy blight\n");}
			else if (TargetStruct->Level >= 3) {strcat(TargetStruct->CharText, "Zauber: Desecrate\n");}
			else if (TargetStruct->Level >= 1) {strcat(TargetStruct->CharText, "Zauber: Darkness 3/day\n");}
		}
	}

	mGetStatic(sisave_SM_TSk, sbsave_SM_TSk, GetTemplateNumber("Skelleton"));
	if (TargetStruct->CRPosTemplate[PosType] == sisave_SM_TSk)
	{
		TargetStruct->MAttackCount = 1;
		TargetStruct->MAttackBonus[0] = TargetStruct->Level / 2 + TargetStruct->Mods[1];
		TargetStruct->MDamageA[0] = 1;
		TargetStruct->MDamageB[0] = 4;
		for (i = GetSizeNumber("Medium");i < TargetStruct->MSize;i++)
		{
			ChangeSizeDmg(&TargetStruct->MDamageA[0], &TargetStruct->MDamageB[0]);
		}
		TargetStruct->MDamageC[0] = TargetStruct->Mods[0];
		TargetStruct->MAttackType[0] = "Klaue";
		TargetStruct->MAttackNumber[0] = 2;
		TargetStruct->MAttackRed[0] = 0;
		TargetStruct->SkillCount = 0;
		TargetStruct->FeatCount = 1;
		mGetStatic(sisave_SM_VI, sbsave_SM_VI, GetFeatNumber("VerbesserteInitiative"));
		TargetStruct->Feats[0] = sisave_SM_VI;
	}

	CalcMods(TargetStruct);
	sprintf(tempout, "MonsterText\\%s", Source.MonsterSource[TargetStruct->MonsterName].Name.buffer);
	if (!(TargetStruct->CRPosTemplate[PosType] == sisave_SM_TSk))
	{
		DoMonsterDesc(TargetStruct, tempout);
		SetMonsterSpellChar(TargetStruct);
	}

	NewType = TargetStruct->MonsterType;
	GetMonsterGARW(TargetStruct, &NewGA, &NewRWRef, &NewRWWil, &NewRWZaeh);
	TargetStruct->MonsterType = NewType;

	TargetStruct->GAMeleeAttr = TargetStruct->Mods[0];
	TargetStruct->GAShotAttr = TargetStruct->Mods[1];
	TargetStruct->GASize = -TargetStruct->MSize + 4;
	if (TargetStruct->GASize == -5) {TargetStruct->GASize++;}
	if (abs(TargetStruct->GASize) == 3) {TargetStruct->GASize = (TargetStruct->GASize * 4) / 3;}
	if (abs(TargetStruct->GASize) == 4) {TargetStruct->GASize = (TargetStruct->GASize * 2);}
	TargetStruct->GAEpic = 0;
	TargetStruct->GAMeleeRest = 0;
	TargetStruct->GAShotRest = 0;
	TargetStruct->GA = NewGA;
	TargetStruct->GAMelee = TargetStruct->GA + TargetStruct->GAMeleeAttr + TargetStruct->GAMeleeRest + TargetStruct->GASize;
	TargetStruct->GAShot = TargetStruct->GA + TargetStruct->GAShotAttr + TargetStruct->GAShotRest + TargetStruct->GASize;

	TargetStruct->RWRefBase = NewRWRef;
	TargetStruct->RWWilBase = NewRWWil;
	TargetStruct->RWZaehBase = NewRWZaeh;

	TargetStruct->RWRefAttr = TargetStruct->Mods[1];
	TargetStruct->RWWilAttr = TargetStruct->Mods[4];
	TargetStruct->RWZaehAttr = TargetStruct->Mods[2];
	
	NewGA -= OldGA;
	NewRWRef -= OldRWRef;
	NewRWWil -= OldRWWil;
	NewRWZaeh -= OldRWZaeh;

	TargetStruct->RWRef += NewRWRef;
	TargetStruct->RWWil += NewRWWil;
	TargetStruct->RWZaeh += NewRWZaeh;

	for (i = 0;i < TargetStruct->MAttackCount;i++)
	{
		TargetStruct->MAttackBonus[i] += NewGA;
	}

	TargetStruct->ACSize = TargetStruct->GASize;
	TargetStruct->ACDex = TargetStruct->Mods[1];
}

int LastMonster = -1;
int LastMonsterType = -1;

clsChar CRTempChar;
int DetermineCRA(int Monster, int HDInc, int Template, int* CRSpace, int Mixed = 0)
{
	int CurCR;
	char* CheckPos;
	int i;
	int Missed;
	
	CurCR = Source.MonsterSource[Monster].CR;

	for (i = 0;i < 2;i++)
	{
		CheckPos = Source.TemplateSource[Template].ForbitType.buffer;
		if (i == 1)
		{
			CheckPos = Source.TemplateSource[Template].ForceType.buffer;
		}
		if (*CheckPos)
		{
			Missed = i;
			while (*CheckPos)
			{
				if (GetMonsterTypeNumber(CheckPos) == Source.MonsterSource[Monster].Type)
				{
					Missed ^= 1;
					break;
				}
				CheckPos += strlen(CheckPos) + 1;
			}
			if (Missed)
			{
				CurCR += 1024;
				break;
			}
		}
	}
	
	if (Mixed && Source.MonsterTypeSource[Source.MonsterSource[Monster].Type].Mixed == 0)
	{
		CurCR += 1024;
	}

	if (Mixed && Source.TemplateSource[Template].Mixed == 0)
	{
		CurCR += 1024;
	}
	mGetStatic(sisave_DCRA_TSk, sbsave_DCRA_TSk, GetTemplateNumber("Skelleton"));
	if (Template == sisave_DCRA_TSk && strstr(Source.MonsterSource[Monster].Name, "ydra") != 0)
	{
		CurCR += 1024;
	}
	
	if (CurCR < 1024 && Source.TemplateSource[Template].CRScript[5] != ';')
	{
		CopyMemory(CRTempChar.Attributes, Source.MonsterSource[Monster].Attr, 6 * sizeof(int));
		FetchVarCounter[0] = CurCR;
		FetchVarCounter[1] = Source.MonsterSource[Monster].HD;
		RunScript(&CRTempChar, NULL, NULL, Source.TemplateSource[Template].CRScript);
		CurCR = FetchVarCounter[0];
	}

	double NewHDMin;
	double NewHDMax;
	double HDLog;
	NewHDMin = Source.MonsterSource[Monster].HD;
	NewHDMax = Source.MonsterSource[Monster].HD;
	switch (HDInc)
	{
	case 0:
		break;
	case 1:
		if (!(Source.MonsterSource[Monster].HDMin > 0)) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDMin == Source.MonsterSource[Monster].HDInc) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc > 0)
		{
			NewHDMin = Source.MonsterSource[Monster].HDMin;
			NewHDMax = Source.MonsterSource[Monster].HDInc - 1;
		}
		else
		{
			NewHDMin = Source.MonsterSource[Monster].HDMin;
			NewHDMax = Source.MonsterSource[Monster].HDMax;
		}
		break;
	case 2:
		if (!(Source.MonsterSource[Monster].HDInc > 0)) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc == Source.MonsterSource[Monster].HDInc2) {CurCR += 1024;}
		if (Source.MonsterSource[Monster].HDInc2 > 0)
		{
			NewHDMin = Source.MonsterSource[Monster].HDInc;
			NewHDMax = Source.MonsterSource[Monster].HDInc2 - 1;
		}
		else
		{
			NewHDMin = Source.MonsterSource[Monster].HDInc;
			NewHDMax = Source.MonsterSource[Monster].HDMax;
		}
		break;
	case 3:
		if (!(Source.MonsterSource[Monster].HDInc2 > 0)) {CurCR += 1024;}
		NewHDMin = Source.MonsterSource[Monster].HDInc2;
		NewHDMax = Source.MonsterSource[Monster].HDMax;
		break;
	}
	NewHDMin /= GreaterZero(Source.MonsterSource[Monster].HD);
	HDLog = log(NewHDMin) / log((double) 2);
	*CRSpace = CurCR;

	CurCR += max(HDInc, (int) (HDLog * 4 + 0.5));

	NewHDMax /= GreaterZero(Source.MonsterSource[Monster].HD);
	HDLog = log(NewHDMax) / log((double) 2);
	*CRSpace += (int) (max(HDInc, (int) (HDLog * 4 + 0.5)));

	return(CurCR);
}

int DetermineCR(int Monster, int HDInc, int Template, int* CRSpace, int Mixed, int Init)
{
	int i, j, k;
	int CurCR;

	if (Init)
	{
		Source.MonsterCR = (int*) mallocl(Source.MonsterSourceCount * Source.TemplateSourceCount * 4 * 2 * sizeof(int), "DetermineCR-MonsterCR");
		for (i = 0;i < Source.MonsterSourceCount;i++)
		{
			for (j = 0;j < Source.TemplateSourceCount;j++)
			{
				for (k = 0;k < 4;k++)
				{
					Source.MonsterCR[(i * Source.TemplateSourceCount * 4 + j * 4 + k) * 2] =
						DetermineCRA(i, k, j, &Source.MonsterCR[(i * Source.TemplateSourceCount * 4 + j * 4 + k) * 2 + 1]);
				}
			}
		}
		return(0);
	}

	CurCR = Source.MonsterCR[(Monster * Source.TemplateSourceCount * 4 + Template * 4 + HDInc) * 2];
	*CRSpace = Source.MonsterCR[(Monster * Source.TemplateSourceCount * 4 + Template * 4 + HDInc) * 2 + 1];

	if (Mixed && Source.MonsterTypeSource[Source.MonsterSource[Monster].Type].Mixed == 0)
	{
		CurCR += 1024;
	}

	if (Mixed && Source.TemplateSource[Template].Mixed == 0)
	{
		CurCR += 1024;
	}

	return(CurCR);
}


int CRPosTemplate[4096][32];
int CRPosHD[4096][32];
int CRPosCR[4096][32];

int DetermineMonster(clsChar* TargetStruct)
{
	int* Prob;
	int* CRPosCount;

	int i, j, k;
	int manualold;

	int a, b;

	Prob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DetermineMonster-Prob");
	CRPosCount = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DetermineMonster-CRPosCount");

	manualold = manual;

	if (ChooseClass)
	{
		manual = 1;
	}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		Prob[i] = 0;
		CRPosCount[i] = 0;
	}

	int usetemplates = 0;
	if (random(0, 5, "0 = Kein Template / 1 = Template") == 1)
	{
		usetemplates = 1;
	}

	TargetStruct->CRPosCount = 0;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		for (j = 0;j < 4;j++)
		{
			for (k = (usetemplates == 1 ? 1 : 0);k < (usetemplates == 1 ? 11 : 1);k++)
			{
				a = DetermineCR(i, j, k, &b, TargetStruct->Mixed);
				if (a <= TargetStruct->HG && b >= TargetStruct->HG)
				{
					Prob[i] ++;
					if (k == 0)
					{
						Prob[i] += 15;
					}
					if (j == 0)
					{
						Prob[i] += 5;
					}
					CRPosHD[i][CRPosCount[i]] = j;
					CRPosTemplate[i][CRPosCount[i]] = k;
					CRPosCR[i][CRPosCount[i]] = a;
					CRPosCount[i]++;
				}
			}
		}
	}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Prob[i])
		{
			if (LastMonster != -1)
			{
				if (i == LastMonster)
				{
					Prob[i] *= 12;
				}
				else
				{
					Prob[i] *= Source.MonsterSource[i].Mixed;
				}
				if (LastMonsterType == Source.MonsterSource[i].Type)
				{
					Prob[i] *= 5;
				}
			}
		}
	}

	int* MonsterTypePresent;
	MonsterTypePresent = (int*) mallocl(Source.MonsterTypeSourceCount * sizeof(int), "DetermineMonster-MonsterTypePresent");
	ZeroMemory(MonsterTypePresent, Source.MonsterTypeSourceCount * sizeof(int));
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Prob[i])
		{
			MonsterTypePresent[Source.MonsterSource[i].Type] = 1;
		}
	}

	adverror = 0;
	j = AdvancedRand(Source.MonsterTypeSourceCount, MonsterTypePresent, sizeof(int),
		(char*) &Source.MonsterTypeSource[0].Name.buffer, sizeof(clsMonsterTypeSource), "Monsterart whlen!", ChooseClass, 1);

	freel(MonsterTypePresent);

	if (j == -1)
	{
		freel(Prob);
		freel(CRPosCount);
		return(1);
	}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (Source.MonsterSource[i].Type != j)
		{
			Prob[i] = 0;
		}
	}
	
	TargetStruct->MonsterName = AdvancedRand(Source.MonsterSourceCount, Prob, sizeof(int), 
		(char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonster),
		"Monster whlen", 0, 1);

	manual = manualold;
	
	TargetStruct->CRPosCount = CRPosCount[TargetStruct->MonsterName];
	for (i = 0;i < TargetStruct->CRPosCount;i++)
	{
		TargetStruct->CRPosTemplate[i] = CRPosTemplate[TargetStruct->MonsterName][i];
		TargetStruct->CRPosHD[i] = CRPosHD[TargetStruct->MonsterName][i];
		TargetStruct->CRPosCR[i] = CRPosCR[TargetStruct->MonsterName][i];
	}
		
	LastMonster = TargetStruct->MonsterName;
	SetMonster(TargetStruct);
	LastMonsterType = TargetStruct->MonsterType;

	freel(Prob);
	freel(CRPosCount);
	return(0);
}
