LARGE_INTEGER qwStartTime, qwEndTime;

void ClearChar(clsChar* TargetStruct)
{
	int i, k;
	CharTemplate* TempSave;

	TempSave = TargetStruct->CreationTemplate;
	TargetStruct->~clsChar();
	ZeroMemory(TargetStruct, sizeof(clsChar));
	TargetStruct->CreationTemplate = TempSave;

	TargetStruct->Domains[0] = -1;
	TargetStruct->Domains[1] = -1;
	for (k = 0;k < 32;k++)
	{
		for (i = 0;i < 10;i++)
		{
			TargetStruct->SpellsKnownCount[k][i] = -1;
			TargetStruct->SpellsPerDayCount[k][i] = -1;
			TargetStruct->SpellListCount[k][i] = -1;
		}
	}
	TargetStruct->Attacks = 1;
	TargetStruct->AttacksOpportunity = 1;
	TargetStruct->MaxDex = 1024;

	TargetStruct->RingMax = 2;

	TargetStruct->InbornLeft = 1;

	DoEffects(NULL, 1);
	DoEffects2(NULL, 0, 1);
}

void CreateCharInit(clsChar* TargetStruct)
{
	int i;

	QueryPerformanceCounter(&qwStartTime);

	if (ChooseClass == 0 && manual == 0 && manual2 == 0 && readreproduce == 0)
	{
		UseIsaac = true;
		reproduceisaac = 1;
		reproduce = 0;
	}

	prepos = (unsigned int*) &CTtmp.re.repos;
	retemp = (unsigned int*) &CTtmp.re.retemp[0];
	*prepos = 0;

	readreproducea = readreproduce;
		
	if (UseIsaac)
	{
		if (!IsaacInitDone)
		{
			isaacinitrand(&TargetStruct->CreationTemplate->seed.seed[0], (readreproduce == 0));
			IsaacInitDone = true;
		}
		readreproducea = readreproduce = 0;
		TargetStruct->CreationTemplate->TemplateType = 49;
	}
	else
	{
		TargetStruct->CreationTemplate->TemplateType = 48;
	}

	prepos = (unsigned int*) &TargetStruct->CreationTemplate->re.repos;
	retemp = (unsigned int*) &TargetStruct->CreationTemplate->re.retemp[0];
	*prepos = 0;

	if (UseIsaac && DebugOutput)
	{
		printf("Charakter Seed:\n");
		for (i = 0;i < 256;i++)
		{
			printf("%2X", TargetStruct->CreationTemplate->seed.seed[i]);
		}
		printf("\n\n");
	}

	CopyMemory(&reheader, TargetStruct->CreationTemplate, sizeof(CharTemplate));
	if (UseIsaac)
	{
		saverep("predefault.rep");
	}
}

void CreateCharExit(clsChar* TargetStruct)
{
	if (TargetStruct->CreationTemplate->Life == -100)
	{
		TPLeft[CurChar] = TargetStruct->Life;
		TargetStruct->CreationTemplate->Life = TargetStruct->Life;
	}
	else
	{
		TPLeft[CurChar] = TargetStruct->CreationTemplate->Life;
	}
		
	QueryPerformanceCounter(&qwEndTime);

	TargetStruct->CreationTime = (int) ((qwEndTime.QuadPart - qwStartTime.QuadPart) * 1000000 / qwFreq);
	saverep("default.rep");
	readreproducea = 0;
}

void CreateChar(clsChar* TargetStruct, bool child = false)
{
	int i, typetemp;

	if (child == false)
	{
		CreateCharInit(TargetStruct);
	}

	ClearChar(TargetStruct);

	FeatNotAgain = (int*) mallocl(Source.FeatSourceCount * sizeof(int), "CreateChar-FeatNotAgain");
	ZeroMemory(FeatNotAgain, Source.FeatSourceCount * sizeof(int));
	
	TargetStruct->Rel = AdvancedRand(Source.RegionSourceCount, &FixedProb, 0, (char*) &Source.RegionSource[0].Name.buffer, sizeof(clsRegionSource), "Region auswhlen!", 0, 1);

	if (DebugOutput) {printf("Starting Character Creation\n");}


	if (TargetStruct->CreationTemplate->Monster == -1)
	{
		TargetStruct->Monster = random(0, 1, "0 Char / 1 Monster");
	}
	else
	{
		TargetStruct->Monster = TargetStruct->CreationTemplate->Monster;
	}

	manual = manual2;
	if (DebugOutput || manual) {printf("\nHG wird festgelegt\n");}

	TargetStruct->HG = random(TargetStruct->CreationTemplate->MinLevel, TargetStruct->CreationTemplate->MaxLevel, "HG der Kreatur whlen!\n", 0);

	if (TargetStruct->Monster)
	{
RedoMixed:
		if (TargetStruct->HG > 1 &&
			(TargetStruct->CreationTemplate->Mixed || (TargetStruct->CreationTemplate->Monster == -1 && random(0, 5, "5 = Mixed") == 5)))
		{
			TargetStruct->Mixed = 1;
			i = random(0, TargetStruct->HG, "Wie viel der HG fr Klasse verwnden?", ChooseClass);
			TargetStruct->HG -= i;
			TargetStruct->MixedHG = i;
		}

		if (TargetStruct->CreationTemplate->MonsterName == -1)
		{
			if (DetermineMonster(TargetStruct) == 1)
			{
				TargetStruct->HG += TargetStruct->MixedHG;
				goto RedoMixed;
			}
		}
		else
		{
			TargetStruct->MonsterName = TargetStruct->CreationTemplate->MonsterName;
			SetMonster(TargetStruct);
		}

		DoDomainsSpecial(TargetStruct);
		CalculateSpellCount(TargetStruct);
		CalculateSpells(TargetStruct);
	}
	else
	{
		TargetStruct->Level = TargetStruct->HG + 1;

		DoTemplateProfile(TargetStruct);

		if (TargetStruct->Profiled)
		{
			typetemp = 1;
		}
		else if (TargetStruct->CreationTemplate->AttributeType == -1)
		{
			typetemp = random(1, 2, "Wrfelmethode whlen: 1 = 3W6, 2 = 4W6\n");
		}
		else
		{
			typetemp = TargetStruct->CreationTemplate->AttributeType;
		}

		if (TargetStruct->CreationTemplate->AttributePreset == 0)
		{
			RandAttributes(TargetStruct, typetemp);
		}
		else
		{
			for (i = 0;i < 6;i++)
			{
				TargetStruct->Attributes[i] = TargetStruct->CreationTemplate->AttributePreset[i];
			}
		}

		DoClasses(TargetStruct, typetemp);

		RaceMod(TargetStruct);
	
		IncreaseAttributes(TargetStruct);
		if (TargetStruct->HasTemplate)
		{
			IncreaseAttributes(TargetStruct, Source.TemplateSource[TargetStruct->HasTemplate].AttributeMod, 6, 1);
		}
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);

		TargetStruct->WeaponArmorShieldFeats = 1;
		if (Source.CharSource[TargetStruct->Classes[HighestVal(TargetStruct->Levels, TargetStruct->ClassCount)]].NoEq == 2)
		{
			if (random(0, 3, "0 > Get All Required Feats for Weapon/Armor/Shield") == 0)
			{
				TargetStruct->WeaponArmorShieldFeats = 0;
			}
		}

		mCheckChars(PsiCrystal);
		if (mCheckCharsResult)
		{
			TargetStruct->CrystalCount++;
		}

		int tempval = 0;
		DoClassRaceFeats(TargetStruct, &tempval);
		
		manual = manual2;
		if (DebugOutput || manual) {printf("\nAngriffsart wird bestimmt\n");}

		DetermineAttackType(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nAusrstung wird bestimmt\n");}

		if (
				(DummyChar == 0) ||
				(Source.MonsterTypeSource[dummySource->MonsterType].MixedEq == 1) ||
					(Source.MonsterTypeSource[dummySource->MonsterType].MixedEq > 1 &&
					random(1, Source.MonsterTypeSource[dummySource->MonsterType].MixedEq, "1 = Mit Ausrstung") == 1)
			)
		{
			GenerateEquipment(TargetStruct);
		}

		TargetStruct->Treasure = random(75, 125, "Geldwert in %%") * Source.Treasure[TargetStruct->HG] / 100 * 2;

		InherentBonus(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nZauber etc werden bestimmt\n");}

		DoDomainsSpecial(TargetStruct);
		CalculateSpellCount(TargetStruct);
		CalculateSpells(TargetStruct);
		DoPowers(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nTalente werden festgelegt\n");}

		if (DummyChar)
		{
			for (i = 0;i < dummySource->FeatCount;i++)
			{
				if (!FeatPresent(TargetStruct, dummySource->Feats[i], TargetStruct->FeatCount, dummySource->FeatDependancy[i]))
				{
					AddFeat(TargetStruct, dummySource->Feats[i], NULL, dummySource->FeatDependancy[i]);
				}
			}
		}

		CalculateFeats(TargetStruct);
		SetFeatSkills(TargetStruct);

		manual = manual2;
		if (DebugOutput) {printf("\nFertigkeiten werden festgelegt\n");}

		CalculateSkills(TargetStruct);
		SetFeatSkillsA(TargetStruct);
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);

		ReArrangeFeats(TargetStruct);

		DoFeatEffects(TargetStruct);

		DoRaceFeatures(TargetStruct);
		DoClassFeatures(TargetStruct);

		DoEffects4(TargetStruct);
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);	

		DoCrystal(TargetStruct);
	
		CalcLife(TargetStruct);

		DoFinalVals(TargetStruct);

		if (TargetStruct->HasTemplate)
		{
			sprintf(tempout, "MonsterText\\%s", Source.TemplateSource[TargetStruct->HasTemplate].Name.buffer);
			DoMonsterDesc(TargetStruct, tempout);
		}
	}

	ExtractSR(TargetStruct);
	freel(FeatNotAgain);

	if (TargetStruct->Mixed == 1)
	{
		if (loop == 0)
		{
			printf("Creating Mixed Char\n");
		}
		MixChar(TargetStruct);
	}
	StripFeats(TargetStruct);

	ReArrangeFeats(TargetStruct);

	if (child == false)
	{
		CreateCharExit(TargetStruct);
	}
}

#include "clsCharDisplay.h"
