#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <winbase.h>

#include "defines.h"
#include "malloclog.h"
#include "include/cpuid.h"
#include "global.h"
#include "include/string.h"
#include "include/classes.h"
#include "include/realloc.h"

//Exports
extern "C" clsSource Source;
clsSource Source;

extern "C" CharTemplate CTtmp;
extern "C" clsChar cDumpChar;
extern "C" clsEquip eDumpEquip;
CharTemplate CTtmp;
clsChar cDumpChar;
clsEquip eDumpEquip;

unsigned long seed[256];

int Moneys[100];
char FullTables[100][BufferLen];
char FullTable[BufferLen];
int TPPos[101];
int TPLeft[101];

char refname[SmallBufferLen]; 

int MustRebuild;
int vAllocOK;
int ReserveHigh = 0;
int dwPageSize;

int TestScript = 0;
int ThrowTestExeption = 0;
int RuntimeChoosen = 0;

unsigned char Colour[125];

int useagain[BufferLen];
int useagainaddr[BufferLen];
int auseagain[BufferLen];
int auseagainaddr[BufferLen];

__int64 qwFreq;

int DebugOutput;
int AllocOutput = 0;

int CompactSourceAllocated = 0;

char tempstring[SmallBufferLen];
char tempout[BufferLen];
char tempout2[BufferLen];
char tempout3[BufferLen];
char tempout4[BufferLen];




#ifdef buildvsnet
	namespace vcnetspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef builddebug
	namespace debugspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef buildintel
	namespace intelspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef buildvectorc
	namespace vectorcspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef buildgcc
	extern "C" void __stdcall _Z14if_gcc_dndmaini(int dump);
#endif

#ifdef buildbcc
	namespace bccspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

int Runtime(int Num, int argc, char** argv)
{
	int Start = Num;
	int restarted = 0;

	goto skiprestart;

restart:
	restarted = 1;
	Num++;
	Num %= 5;

	if (Num == Start)
	{
		printf("No suitable Runtime found\n");
		getchar();
		return(1);
	}

skiprestart:

	if (Num == 0)
	{
#ifdef builddebug
		printf("\nRunning Debug Code\n");
		return(debugspace::dndmain(argc, argv));
#else
		printf("Debug Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 1)
	{
#ifdef buildintel
		printf("\nRunning Intel Compiler Northwood Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(intelspace::dndmain(argc, argv));
#else
		printf("Intel Compiler Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 2)
	{
#ifdef buildvectorc
		printf("\nRunning VectorC Compiler Optimized Code\n");
		if (isAthlon() == FALSE)
		{
			printf("WARNING, NO AMD CPU FOUND\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(vectorcspace::dndmain(argc, argv));
#else
		printf("VectorC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 3)
	{
#ifdef buildgcc
		printf("\nRunning GCC Compiler SSE2 Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		_Z14if_gcc_dndmaini(0);
		return(0);
#else
		printf("GCC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 4)
	{
#ifdef buildvsnet
		printf("Running Visual C++ .NET Compiler Optimized Code\n");
		return(vcnetspace::dndmain(argc, argv));
#else
		printf("Visual C++ .NET Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	printf("Unknown Runtime\nExiting...\n");
	getchar();
	return(1);
}

int CheckSaveDir()
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;

	hFindFile = FindFirstFile("save", &FindData);

	if (hFindFile != INVALID_HANDLE_VALUE)
	{
		FindClose(hFindFile);
		if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		{
			return(0);
		}
	}

	return(!CreateDirectory("save", NULL));
}

#ifdef AllowFloatTest
namespace debugspace {double CheckFloat(double val);}
namespace intelspace {double CheckFloat(double val);}
namespace vectorcspace {double CheckFloat(double val);}
namespace gccspace {extern "C" double if_gcc_CheckFloat(double val);}
namespace vcnetspace {double CheckFloat(double val);}
int CheckFloatConsistence()
{
	printf("Checking Float Consistence\n");
	double valdebug, valintel, valvectorc, valgcc, valvcnet;

	valdebug = debugspace::CheckFloat(10);

	if (HasSSE2())
	{
		valintel = intelspace::CheckFloat(10);
		valgcc = gccspace::if_gcc_CheckFloat(10);
	}
	else
	{
		printf("Skipping Intel Compiler and GCC as not SSE2 support was found\n");
		valintel = valdebug;
		valgcc = valdebug;
	}

	if (isAthlon())
	{
		valvectorc = vectorcspace::CheckFloat(10);
	}
	else
	{
		printf("Skipping VectorC as no Athlon CPU was found\n");
		valvectorc = valdebug;
	}
	valvcnet = vcnetspace::CheckFloat(10);

	if (valdebug != valintel || valdebug != valvectorc || valdebug != valgcc || valdebug != valvcnet)
	{
		printf("Float not consistent between Compilers\n");
	}
	else
	{
		printf("Float consistent\n");
	}

	return(0);
}
#endif

int main(int argc, char** argv)
{
	int StdRun;
	int RetVal, RetVal2 = 0;

	SYSTEM_INFO sSysInfo;
	GetSystemInfo(&sSysInfo);
	dwPageSize = sSysInfo.dwPageSize;

	printf("DND Chargen V. 0.9 Coded by qon in 2k4\n\n");

#ifdef AllowFloatTest
	CheckFloatConsistence();
#endif

	if (CheckSaveDir())
	{
		printf("Cannot Create Save Directory\n");
		RetVal = 1;
		goto mainend;
	}
	QueryPerformanceFrequency((LARGE_INTEGER*) &qwFreq);

#ifdef DumpSource
	LPVOID vAlloc;
	vAlloc = VirtualAlloc((void*) VirtualReserveBase, VirtualReserveSize, MEM_RESERVE, PAGE_READWRITE);
	vAllocOK = (vAlloc != NULL);
#endif

#ifdef DumpSourceLoad
	if (MustRebuild = ReAlloc("source.dnd", &Source, sizeof(clsSource), &bnf::SymbolNames, 0))
	{
		printf("will rebuild later...\n\n");
	}
#else
	MustRebuild = 1;
#endif

	if (argc == 2)
	{
		StdRun = atoi(argv[1]);
		printf("Runtime choosen by Argument\n");
	}
	else if (HasSSE2())
	{
		printf("SSE2 capable CPU found, using Intel Compiler Runtime\n\n");
		StdRun = 1;
	}
	else
	{
		printf("No SSE2 capable CPU found, using Microsoft Compiler Generic Runtime\n\n");
		StdRun = 4;
	}

	RetVal = Runtime(StdRun, argc, argv);

#ifdef DumpSource
	if (!VirtualFree((void*) VirtualReserveBase, 0, MEM_RELEASE))
	{
		RetVal2 = 1;
	}
#endif

	if ((CompactSourceAllocated && (!VirtualFree((void*) VirtualCompactBase, 0, MEM_RELEASE))) || RetVal2)
	{
		printf("Failed freeing Memory for some reason, Should make a difference yet though :|\n\n");
		RetVal = 1;
	}


	if (!MustRebuild && !TestScript)
	{
		free(bnf::SymbolNames);
	}
	ZeroMemory(&Source, sizeof(clsSource));

#ifdef malloclog
	ListAlloc();
#endif

mainend:
	while (kbhit()) {getch();}
	if (RetVal)
	{
		printf("Aborting...\n");
		getchar();
	}
	else
	{
		printf("\nExiting...\n");
	}
	return(RetVal);
}

void breakpoint(char* Text)
{
	throw(Text);
}